/*******************************************************************
$Header: C:/Symbol/Csp32Proj/VcCspDemo/src/vcs/VcCspDemoDlg.cpv  1.0  20 Mar 1999  12:00:00 jTykowski $
 *
 *  Copyright 1999 Peninsula Solutions, Inc., all rights reserved.
 *  Copyright 1999 Symbol Technologies, Inc., all rights reserved.
 *
 *          ***************************************
 *          * This file was generated by:         *
 *          *       Peninsula Solutions, Inc.     *
 *          *       1265 S. Semoran Blvd.         *
 *          *       Suite 1247                    *     
 *          *       Winter Park, FL 32792         *
 *          *       Phone: (407) 673-6544         *
 *          *       Fax:   (407) 673-6545         *
 *          * E-mail: info@PeninsulaSolutions.com *
 *          *                                     *
 *          * under a grant from:                 *
 *          *       Symbol Technologies, Inc.     *
 *          *       Holtsville, NY                *
 *          ***************************************
 *
 * The user is granted a license to use and modify this file for their own
 * purposes so long as the Copyright information remains intact.
 *
 *    MODULE NAME:   CommTestDlg.cpp
 *
 *    DESCRIPTION:
 *                   This file provides the dialog based control
 *                   handling functions for the CommTest.exe
 *                   program. 
 *
 *    AUTHOR:        Joe Tykowski
 *
 *    DATE CREATED:  03/11/99
 *
 *    HISTORY:
 *
 *       03/11/99    Initial Development
 *
$Log: C:/Symbol/Csp32Proj/VcCspDemo/src/vcs/VcCspDemoDlg.cpv $
 *******************************************************************/

/** include files **/
#include "stdafx.h"
#include "VcCspDemo.h"
#include "VcCspDemoDlg.h"
#include "CommDialog.h"
#include "csp32.h"
#include <stdio.h>
#include "winuser.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// flag indicating whether debug file logging is enabled or disabled
BOOL    bLogEnabled;

// Comm Port selected via dialog
long    nActivePort = -1;

// Default value for retry operation
long    nRetryCount;

// storage for status display strings
char    aTlBits[8];
char    szUserId[9];
long	nParam;

// pointers to status display controls
CWnd    *lpszPenId;
CWnd    *lpszSignature;
CWnd    *lpszSwVersion;
CWnd    *lpnProtocol;
CWnd    *lpnSystemStatus;

// local function prototypes
void    errorMsg( long nRetStatus );
void    showStats(void);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVcCspDemoDlg dialog

CVcCspDemoDlg::CVcCspDemoDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CVcCspDemoDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CVcCspDemoDlg)
    m_nRetryCount = 5;
	//}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVcCspDemoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CVcCspDemoDlg)
    DDX_Text(pDX, IDC_RETRY_COUNT, m_nRetryCount);
    DDV_MinMaxUInt(pDX, m_nRetryCount, 0, 9);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVcCspDemoDlg, CDialog)
    //{{AFX_MSG_MAP(CVcCspDemoDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_PORT_SETUP, OnPortSetup)
    ON_BN_CLICKED(IDC_INIT_COM, OnInitCom)
    ON_BN_CLICKED(IDC_RESTORE_COM, OnRestoreCom)
    ON_BN_CLICKED(IDC_LOG_ENABLE, OnLogEnable)
    ON_BN_CLICKED(IDC_READ_PEN, OnReadPen)
    ON_BN_CLICKED(IDC_CLEAR_PEN, OnClearPen)
    ON_BN_CLICKED(IDC_POWER_DOWN, OnPowerDown)
    ON_BN_CLICKED(IDC_BC_REDUNDANCY_SET, OnBcRedundancySet)
    ON_BN_CLICKED(IDC_BC_REDUNDANCY_READ, OnBcRedundancyRead)
    ON_BN_CLICKED(IDC_VOLUME_SET, OnVolumeSet)
    ON_BN_CLICKED(IDC_VOLUME_READ, OnVolumeRead)
    ON_BN_CLICKED(IDC_CONTINUOUS_SCAN_SET, OnContinuousScanSet)
    ON_BN_CLICKED(IDC_CONTINUOUS_SCAN_READ, OnContinuousScanRead)
    ON_BN_CLICKED(IDC_TL_BITS_SET, OnTlBitsSet)
    ON_BN_CLICKED(IDC_TL_BITS_READ, OnTlBitsRead)
    ON_BN_CLICKED(IDC_USER_ID_SET, OnUserIdSet)
    ON_BN_CLICKED(IDC_USER_ID_READ, OnUserIdRead)
    ON_EN_KILLFOCUS(IDC_RETRY_COUNT, OnKillfocusRetryCount)
    ON_EN_KILLFOCUS(IDC_TL_BITS_0, OnKillfocusTlBits0)
    ON_EN_KILLFOCUS(IDC_TL_BITS_1, OnKillfocusTlBits1)
    ON_EN_KILLFOCUS(IDC_TL_BITS_2, OnKillfocusTlBits2)
    ON_EN_KILLFOCUS(IDC_TL_BITS_3, OnKillfocusTlBits3)
    ON_EN_KILLFOCUS(IDC_TL_BITS_4, OnKillfocusTlBits4)
    ON_EN_KILLFOCUS(IDC_TL_BITS_5, OnKillfocusTlBits5)
    ON_EN_KILLFOCUS(IDC_TL_BITS_6, OnKillfocusTlBits6)
    ON_EN_KILLFOCUS(IDC_TL_BITS_7, OnKillfocusTlBits7)
    ON_EN_KILLFOCUS(IDC_USER_ID, OnKillfocusUserId)
    ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_PARAMETER_READ, OnParameterRead)
	ON_BN_CLICKED(IDC_PARAMETER_SET, OnParameterSet)
	ON_BN_CLICKED(IDC_PARAMETER_ENABLE, OnParameterEnable)
	ON_BN_CLICKED(IDC_PARAMETER_DISABLE, OnParameterDisable)
	ON_EN_KILLFOCUS(IDC_PARAMETER, OnKillfocusParameter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVcCspDemoDlg message handlers
/*
 ** BOOL CVcCspDemoDlg::OnInitDialog()
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Initializes the controls and strings required
 *                  for use with this dialog box.
 *
 *  RETURNS:        TRUE
 *
 */

BOOL CVcCspDemoDlg::OnInitDialog()
{
    CSpinButtonCtrl *s1;
    CButton         *b1;
    char            szData[20];

    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
    {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
        {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon
    
    // show that data logging is disabled
    bLogEnabled = FALSE;
    b1 = (CButton *) GetDlgItem(IDC_LOG_ENABLE);
    b1->SetWindowText( "Log Disabled" );
    
    // set the spin control range in [0..9]
    s1 = (CSpinButtonCtrl *) GetDlgItem(IDC_RETRY_SPIN);
    s1->SetRange(0, 9);

    // Display the FileVersion information in the About dialog box...
    cspGetDllVersion(szData, sizeof(szData));
    GetDlgItem(IDC_DLL_VERSION)->SetWindowText(szData);
    
    // initialize the TL Bits
    memset(aTlBits, 0, sizeof(aTlBits));

    // initialize the User ID
    memset(szUserId, 0, sizeof(szUserId));
    
    lpszPenId       = GetDlgItem(IDC_PEN_ID_HEX);
    lpszSignature   = GetDlgItem(IDC_SIGNATURE_HEX);
    lpszSwVersion   = GetDlgItem(IDC_SOFTWARE_VERSION);
    lpnProtocol     = GetDlgItem(IDC_PROTOCOL_VERSION);
    lpnSystemStatus = GetDlgItem(IDC_SYSTEM_STATUS);

    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVcCspDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVcCspDemoDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVcCspDemoDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

/*
 ** void CVcCspDemoDlg::OnPortSetup() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function displays the CommDialog box. It is
 *                  used to establish which communications port the 
 *                  CSP device should be connected to.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnPortSetup() 
{
    long    nResponse;

    CCommDialog dlg(this);

    // set the member variable for the new dialog box to the current port setting
    dlg.m_nActivePort = nActivePort;

    // start up the new dialog box
    nResponse = dlg.DoModal();

    // check the response to see how the dialog box was exited...
    if (nResponse == IDOK)
    {
        //  dismissed with OK, verify the member setting
        if (dlg.m_nActivePort >= COM1)
        {
            // everything is OK, we have a new port selected
            nActivePort = dlg.m_nActivePort;
        }
    }
}

/*
 ** void CVcCspDemoDlg::OnInitCom() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function tries to establish the Comm port which will
 *                  be used for communicating with the CSP device.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnInitCom() 
{
    long    nRetStatus;
    char    szStatus[80];

    // verify that we have a valid comm port to program...
    if (nActivePort < COM1)
    {
        MessageBox("No Valid RS-232 Comm port selected.\r\nPlease select a valid port before trying this operation.", "Comm Port Error", MB_OK | MB_ICONHAND);
    }
    // try to initialize the port
    else if ((nRetStatus = cspInit(nActivePort)) != STATUS_OK)
    {
        // error condition, alert the user of the problem
        wsprintf((LPSTR) szStatus, "Comm port not initialized.\r\nError Status: %d", nRetStatus);
        MessageBox((LPCTSTR) szStatus, "Comm Port Error", MB_OK | MB_ICONHAND);
    }
}

/*
 ** void CVcCspDemoDlg::OnRestoreCom() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function releases the communications port which is used
 *                  for communicating with the CSP device.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnRestoreCom() 
{
    // restore the comm port to inactive status, allow other programs to use it
    cspRestore();   
    nActivePort = -1;
}

/*
 ** void CVcCspDemoDlg::OnKillfocusRetryCount() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function sets the number of retries that the user has 
 *                  specified for all future CSP communications.
 *                  This function only allows values in the range [0..9]
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusRetryCount() 
{
    BOOL bTrans;

    // retrieve the last setting from the dialog item...
    nRetryCount = (long) GetDlgItemInt(IDC_RETRY_COUNT, &bTrans, FALSE);

    // set the new retry count
    cspSetRetryCount( nRetryCount );

    // and display the actual setting
    SetDlgItemInt(IDC_RETRY_COUNT, nRetryCount = cspGetRetryCount(), FALSE);
}

/*
 ** void CVcCspDemoDlg::OnLogEnable() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function toggles the "Log Disable" / "Log Enabled"
 *                  button on the display. This function only works with
 *                  the DEBUG version of the CSP DLL.
 *
 *                  When the log is enabled, the CSP DLL will create a 
 *                  "debug.txt" file of all CSP transfers.
 *
 *                  When the log is disabled, the CSP DLL launches NotePad
 *                  to display the debug.txt log file that was created.
 *
 *                  Every time that the log file option is toggled, the 
 *                  previous log file is overwritten and any previous information
 *                  is lost.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnLogEnable() 
{
    CButton     *b1;

    // get a pointer to the button
    b1 = (CButton *) GetDlgItem(IDC_LOG_ENABLE);

    // what state is the button currently in?
    if (bLogEnabled)
    {
        // switch the button's state
        bLogEnabled = FALSE;

        // change the button's text string
        b1->SetWindowText( "Log Disabled" );

        // set the debug mode off 
        cspSetDebugMode(PARAM_OFF);
        
        // display the log file...
        WinExec("notepad debug.txt", SW_SHOW);
    }
    else
    {
        // switch the button's state
        bLogEnabled = TRUE;

        // change the button's text string
        b1->SetWindowText( "Log Enabled" );

        // set the debug mode on
        cspSetDebugMode(PARAM_ON);
    }
    
}

/*
 ** void CVcCspDemoDlg::OnReadPen() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function reads the barcode data that is stored in the
 *                  CSP device. If the read is successful, it creates a file
 *                  "barcodes.txt" containing the number of barcodes and
 *                  each of the barcode strings. NotePad is launched to display
 *                  the barcode file.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnReadPen() 
{
    HANDLE  hCspText;           // handle to barcode text file
    char    szCspText[80];      // Barcode text
    DWORD   nCspTextLength;     // number of characters in barcode text string
    int i;                      // for loop index
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to read the data from the CSP Device...
    // how many barcodes are stored in the CSP Device?
    nRetStatus = cspReadData();

    // Restore the previous cursor.
    SetCursor(hcurSave);

    if (nRetStatus < STATUS_OK)
        errorMsg( nRetStatus );     // display what went wrong...
    else
    {
        // update the device status...
        showStats();

        // create the debug file...
        hCspText  = CreateFile("barcodes.txt",              // barcode text file name
                                GENERIC_WRITE,              // we are going to write this file
                                0,                          // file sharing disabled
                                0,                          // use default security descriptor
                                CREATE_ALWAYS,              // re-write previously existing file
                                FILE_ATTRIBUTE_NORMAL,      // default file attributes
                                0);                         // no template file provided

        // did we create the file successfully?
        if ( !hCspText )
            {
            // display file creation error message...
            MessageBox("Could not create barcode data file BARCODES.TXT", 
                       "File Creation Error", 
                       MB_OK | MB_ICONHAND);
            return;            
            }

        // caption for the text file...
        nCspTextLength = wsprintf( (LPTSTR) szCspText, 
                                   "Consumer Scanning Products Barcode File: %d Barcodes\r\n\r\n", 
                                   nRetStatus);
        WriteFile(  hCspText,           // handle to debug text file
                    szCspText,          // buffer of data to write to file
                    nCspTextLength,     // number of bytes to write
                    &nCspTextLength,    // number of bytes written
                    0);                 // no overlapped structure present

        // print out the barcodes...
        for (i = 0; i < nRetStatus; i++)
        {
            // read the barcode...
            nCspTextLength = cspGetBarcode(szCspText, i, sizeof(szCspText));

            // subtract out the null terminator
            nCspTextLength--;

            // add <CR><LF> to string...
            strncat( (LPSTR) szCspText, (LPSTR) "\r\n", 2);

            // and write the string to the file...
            WriteFile(  hCspText,           // handle to debug text file
                        szCspText,          // buffer of data to write to file
                        nCspTextLength+2,   // number of bytes to write
                        &nCspTextLength,    // number of bytes written
                        0);                 // no overlapped structure present
        }

        // close the file
        if ( !CloseHandle( hCspText ) )
        {
            // display file close error message...
            MessageBox("Could not close barcode data file  BARCODES.TXT", 
                       "File Close Error", 
                       MB_OK | MB_ICONHAND);
        }
        else
            WinExec("notepad barcodes.txt", SW_SHOW);

    }

}

/*
 ** void CVcCspDemoDlg::OnClearPen() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function clears the barcodes stored in the CSP device.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnClearPen() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to clear the barcodes stored in the CSP device
    nRetStatus = cspClearBarCodes();

    // Restore the previous cursor.
    SetCursor(hcurSave);
    
    if (nRetStatus < STATUS_OK)
        {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
        }

    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnPowerDown() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function is used to put the CSP device in a low
 *                  power mode of operation.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnPowerDown() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to power down the CSP Device
    nRetStatus = cspPowerDown();

    // Restore the previous cursor.
    SetCursor(hcurSave);
}


/*
 ** void CVcCspDemoDlg::OnBcRedundancySet() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function sets the CSP device's Barcode redundancy
 *                  setting if a valid setting has been selected in the 
 *                  dialog box.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnBcRedundancySet() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // check the current state of the radio buttons
    if ( IsDlgButtonChecked(IDC_BC_REDUNDANCY_ENABLE) )
       nRetStatus = cspSetBarcodeRedundancy(PARAM_ON);
    else if ( IsDlgButtonChecked(IDC_BC_REDUNDANCY_DISABLE) )
       nRetStatus = cspSetBarcodeRedundancy(PARAM_OFF);
    else
    {
       // Restore the previous cursor.
       SetCursor(hcurSave);
       return;  
    }

    // Restore the previous cursor.
    SetCursor(hcurSave);

    if (nRetStatus < STATUS_OK)
        {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
        }

    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnBcRedundancyRead() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function updates the dialog box with the current
 *                  CSP Device Barcode Redundancy setting.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnBcRedundancyRead() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to get the barcode redundancy setting
    nRetStatus = cspGetBarcodeRedundancy();

    // Restore the previous cursor.
    SetCursor(hcurSave);
    
    if (nRetStatus < STATUS_OK)
    {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
    }
    else
    {
        // display the current setting...
        if (nRetStatus)
            CheckRadioButton( IDC_BC_REDUNDANCY_ENABLE, 
                              IDC_BC_REDUNDANCY_DISABLE, 
                              IDC_BC_REDUNDANCY_ENABLE);
        else
            CheckRadioButton( IDC_BC_REDUNDANCY_ENABLE, 
                              IDC_BC_REDUNDANCY_DISABLE, 
                              IDC_BC_REDUNDANCY_DISABLE);
    }
    
    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnVolumeSet() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function sets the CSP device's beeper Volume
 *                  setting if a valid setting has been selected in the 
 *                  dialog box.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnVolumeSet() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // check the current state of the radio buttons
    if ( IsDlgButtonChecked(IDC_VOLUME_QUIET) )
       nRetStatus = cspSetVolume(VOLUME_QUIET);
    else if ( IsDlgButtonChecked(IDC_VOLUME_LOW) )
       nRetStatus = cspSetVolume(VOLUME_LOW);
    else if ( IsDlgButtonChecked(IDC_VOLUME_MEDIUM) )
       nRetStatus = cspSetVolume(VOLUME_MEDIUM);
    else if ( IsDlgButtonChecked(IDC_VOLUME_HIGH) )
       nRetStatus = cspSetVolume(VOLUME_HIGH);
    else
    {
       // Restore the previous cursor.
       SetCursor(hcurSave);
       return;  
    }

    // Restore the previous cursor.
    SetCursor(hcurSave);

    if (nRetStatus < STATUS_OK)
        {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
        }
    
    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnVolumeRead() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function updates the dialog box with the current
 *                  CSP Device beeper Volume setting.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnVolumeRead() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to get the volume setting
    nRetStatus = cspGetVolume();

    // Restore the previous cursor.
    SetCursor(hcurSave);
    
    if (nRetStatus < STATUS_OK)
    {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
    }
    else
    {
        // display the current setting...
        switch( nRetStatus )
        {
            case VOLUME_QUIET:
                CheckRadioButton( IDC_VOLUME_QUIET, IDC_VOLUME_HIGH, IDC_VOLUME_QUIET);
                break;

            case VOLUME_LOW:
                CheckRadioButton( IDC_VOLUME_QUIET, IDC_VOLUME_HIGH, IDC_VOLUME_LOW);
                break;

            case VOLUME_MEDIUM:
                CheckRadioButton( IDC_VOLUME_QUIET, IDC_VOLUME_HIGH, IDC_VOLUME_MEDIUM);
                break;

            case VOLUME_HIGH:
                CheckRadioButton( IDC_VOLUME_QUIET, IDC_VOLUME_HIGH, IDC_VOLUME_HIGH);
                break;

            default:
                break;
        }
    }
    
    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnContinuousScanSet() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function sets the CSP device's Continuous Scan
 *                  setting if a valid setting has been selected in the 
 *                  dialog box.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnContinuousScanSet() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // check the current state of the radio buttons
    if ( IsDlgButtonChecked(IDC_CONTINUOUS_SCAN_ENABLE) )
       nRetStatus = cspSetContinuousScanning(PARAM_ON);
    else if ( IsDlgButtonChecked(IDC_CONTINUOUS_SCAN_DISABLE) )
       nRetStatus = cspSetContinuousScanning(PARAM_OFF);
    else
    {
       // Restore the previous cursor.
       SetCursor(hcurSave);
       return;  
    }

    // Restore the previous cursor.
    SetCursor(hcurSave);
    
    if (nRetStatus < STATUS_OK)
        {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
        }
    
    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnContinuousScanRead() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function updates the dialog box with the current
 *                  CSP Device Continuous Scan setting.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnContinuousScanRead() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to get the continuous scan setting
    nRetStatus = cspGetContinuousScanning();

    // Restore the previous cursor.
    SetCursor(hcurSave);
    
    if (nRetStatus < STATUS_OK)
    {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
    }
    else
    {
        // display the current setting...
        if (nRetStatus)
            CheckRadioButton( IDC_CONTINUOUS_SCAN_ENABLE, 
                              IDC_CONTINUOUS_SCAN_DISABLE, 
                              IDC_CONTINUOUS_SCAN_ENABLE);
        else
            CheckRadioButton( IDC_CONTINUOUS_SCAN_ENABLE, 
                              IDC_CONTINUOUS_SCAN_DISABLE, 
                              IDC_CONTINUOUS_SCAN_DISABLE);
    }
    
    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnKillfocusTlBits0() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the specified byte in the TL Bits array based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusTlBits0() 
{
    char Str[3];
    int nBits;

    GetDlgItemText(IDC_TL_BITS_0, Str, sizeof(Str));
    if ( sscanf( (const char *) Str, "%x", &nBits) )
        aTlBits[0] = (char) nBits;
}

/*
 ** void CVcCspDemoDlg::OnKillfocusTlBits1() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the specified byte in the TL Bits array based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusTlBits1() 
{
    char Str[3];
    int nBits;

    GetDlgItemText(IDC_TL_BITS_1, Str, sizeof(Str));
    if ( sscanf( (const char *) Str, "%x", &nBits) )
        aTlBits[1] = (char) nBits;
    
}

/*
 ** void CVcCspDemoDlg::OnKillfocusTlBits2() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the specified byte in the TL Bits array based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusTlBits2() 
{
    char Str[3];
    int nBits;

    GetDlgItemText(IDC_TL_BITS_2, Str, sizeof(Str));
    if ( sscanf( (const char *) Str, "%x", &nBits) )
        aTlBits[2] = (char) nBits;
    
}

/*
 ** void CVcCspDemoDlg::OnKillfocusTlBits3() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the specified byte in the TL Bits array based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusTlBits3() 
{
    char Str[3];
    int nBits;

    GetDlgItemText(IDC_TL_BITS_3, Str, sizeof(Str));
    if ( sscanf( (const char *) Str, "%x", &nBits) )
        aTlBits[3] = (char) nBits;
    
}

/*
 ** void CVcCspDemoDlg::OnKillfocusTlBits4() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the specified byte in the TL Bits array based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusTlBits4() 
{
    char Str[3];
    int nBits;

    GetDlgItemText(IDC_TL_BITS_4, Str, sizeof(Str));
    if ( sscanf( (const char *) Str, "%x", &nBits) )
        aTlBits[4] = (char) nBits;
    
}

/*
 ** void CVcCspDemoDlg::OnKillfocusTlBits5() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the specified byte in the TL Bits array based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusTlBits5() 
{
    char Str[3];
    int nBits;

    GetDlgItemText(IDC_TL_BITS_5, Str, sizeof(Str));
    if ( sscanf( (const char *) Str, "%x", &nBits) )
        aTlBits[5] = (char) nBits;
    
}

/*
 ** void CVcCspDemoDlg::OnKillfocusTlBits6() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the specified byte in the TL Bits array based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusTlBits6() 
{
    char Str[3];
    int nBits;

    GetDlgItemText(IDC_TL_BITS_6, Str, sizeof(Str));
    if ( sscanf( (const char *) Str, "%x", &nBits) )
        aTlBits[6] = (char) nBits;
    
}

/*
 ** void CVcCspDemoDlg::OnKillfocusTlBits7() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the specified byte in the TL Bits array based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnKillfocusTlBits7() 
{
    char Str[3];
    int nBits;

    GetDlgItemText(IDC_TL_BITS_7, Str, sizeof(Str));
    if ( sscanf( (const char *) Str, "%x", &nBits) )
        aTlBits[7] = (char) nBits;
    
}

/*
 ** void CVcCspDemoDlg::OnTlBitsRead() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function updates the dialog box with the current
 *                  CSP Device TL Bits setting.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnTlBitsRead() 
{
    long    nRetStatus;         // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    int     i;                  // index to TL Bits 
    char    szStatus[10];       // formatting buffer
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to get the TL Bits setting
    nRetStatus = cspGetTlBits(aTlBits, sizeof(aTlBits));

    // Restore the previous cursor.
    SetCursor(hcurSave);
    
    if (nRetStatus < STATUS_OK)
    {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
    }
    else
    {
        // display the current setting...
        for (i = 0; i < 8; i++)
        {
            wsprintf((LPSTR) szStatus, "%02X", (int) (aTlBits[i] & 0xFF));
            SetDlgItemText(IDC_TL_BITS_0 + i, szStatus);
        }
    }

    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnTlBitsSet() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function sets the CSP device's TL Bits
 *                  setting if a valid setting has been selected in the 
 *                  dialog box.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnTlBitsSet() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation

    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));

    // set the TL bits using the current settings
    nRetStatus = cspSetTlBits(aTlBits, sizeof(aTlBits));

    // Restore the previous cursor.
    SetCursor(hcurSave);

    if (nRetStatus < STATUS_OK)
        {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
        }
    
    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnKillfocusUserId() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    Update the User ID string based
 *                  on the user input.
 *
 *  RETURNS:        void
 *
 */
void CVcCspDemoDlg::OnKillfocusUserId() 
{
    // retrieve the User ID string from the dialog box
    GetDlgItemText(IDC_USER_ID, szUserId, sizeof(szUserId));
    
    // display the current setting...
    SetDlgItemText(IDC_USER_ID, szUserId);
}

/*
 ** void CVcCspDemoDlg::OnUserIdSet() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function sets the CSP device's User ID.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnUserIdSet() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation

    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // set the User ID using the current settings
    nRetStatus = cspSetUserId(szUserId, sizeof(szUserId));

    // Restore the previous cursor.
    SetCursor(hcurSave);

    if (nRetStatus < STATUS_OK)
        {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
        }
    
    // update the device status...
    showStats();
}

/*
 ** void CVcCspDemoDlg::OnUserIdRead() 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function reads the CSP device's User ID.
 *
 *  RETURNS:        void
 *
 */

void CVcCspDemoDlg::OnUserIdRead() 
{
    long    nRetStatus;         // returned status
    HCURSOR hcurSave;           // change cursor during load operation
    
    // change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to get the User ID setting
    nRetStatus = cspGetUserID(szUserId, sizeof(szUserId));

    // Restore the previous cursor.
    SetCursor(hcurSave);
    
    if (nRetStatus < STATUS_OK)
    {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
    }
    else
    {
        // display the current setting...
        SetDlgItemText(IDC_USER_ID, szUserId);
    }
    
    // update the device status...
    showStats();
}

/*
 ** void errorMsg( long nRetStatus )
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     nRetStatus is a CSP DLL return code.
 *
 *  DESCRIPTION:    This function displays a Message Box to alert the user
 *                  if an error has occured. This function displays error
 *                  messages for the following conditions:
 *                      COMMUNICATIONS_ERROR
 *                      BAD_PARAM
 *                      SETUP_ERROR
 *                      INVALID_COMMAND_NUMBER
 *                      COMMAND_LRC_ERROR
 *                      RECEIVED_CHARACTER_ERROR
 *                      GENERAL_ERROR
 *                      FILE_NOT_FOUND
 *                      ACCESS_DENIED
 *
 *  RETURNS:        void
 *
 */

void errorMsg( long nRetStatus )
{
    switch ( nRetStatus )
    {
        case STATUS_OK:                       
            break;

        case COMMUNICATIONS_ERROR:            
            if (nActivePort < COM1)
                MessageBox(NULL, 
                           "No Valid RS-232 Comm port selected.\r\nPlease select a valid port before trying this operation.", "Comm Port Error", 
                           MB_OK | MB_ICONHAND);
            else
                MessageBox(NULL, 
                           "Returned Status: COMMUNICATIONS_ERROR.\rTry activating CyberPen and retrying operation.", "Error", 
                           MB_OK | MB_ICONHAND);
            break;

        case BAD_PARAM:                       
            MessageBox(NULL, "Returned Status: BAD_PARAM.", "Error", MB_OK | MB_ICONHAND);
            break;

        case SETUP_ERROR:                     
            MessageBox(NULL, "Returned Status: SETUP_ERROR.", "Error", MB_OK | MB_ICONHAND);
            break;

        case INVALID_COMMAND_NUMBER:          
            MessageBox(NULL, "Returned Status: INVALID_COMMAND_NUMBER.", "Error", MB_OK | MB_ICONHAND);
            break;

        case COMMAND_LRC_ERROR:               
            MessageBox(NULL, "Returned Status: COMMAND_LRC_ERROR.", "Error", MB_OK | MB_ICONHAND);
            break;

        case RECEIVED_CHARACTER_ERROR:        
            MessageBox(NULL, "Returned Status: RECEIVED_CHARACTER_ERROR.", "Error", MB_OK | MB_ICONHAND);
            break;

        case GENERAL_ERROR:                   
            MessageBox(NULL, "Returned Status: GENERAL_ERROR.", "Error", MB_OK | MB_ICONHAND);
            break;

        case FILE_NOT_FOUND:                    
            MessageBox(NULL, "Returned Status: FILE_NOT_FOUND.", "Error", MB_OK | MB_ICONHAND);
            break;

        case ACCESS_DENIED:                 
            MessageBox(NULL, "Returned Status: ACCESS_DENIED.", "Error", MB_OK | MB_ICONHAND);
            break;

        default:        
            break;
    }

}

/*
 ** void showStats()
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     void
 *
 *  DESCRIPTION:    This function updates the status display on the 
 *                  the demo dialog box.
 *
 *  RETURNS:        void
 *
 */

void showStats()
{
    char szPenId[9];
    char szSwVersion[9];
    char aSignature[8];
    char szStatus[20];

    // is a comm port selected?
    if (nActivePort < COM1)
        return; 

    // retrieve the CSP ID and show it on the display
    cspGetDeviceId(szPenId, sizeof(szPenId));
    lpszPenId->SetWindowText(szPenId);

    // retrieve the CSP signature and show it on the display
    cspGetSignature(aSignature, sizeof(aSignature));
    wsprintf((LPSTR) szStatus, "%02X%02X%02X%02X%02X%02X%02X%02X", 
        (int) (aSignature[0] & 0xFF),
        (int) (aSignature[1] & 0xFF),
        (int) (aSignature[2] & 0xFF),
        (int) (aSignature[3] & 0xFF),
        (int) (aSignature[4] & 0xFF),
        (int) (aSignature[5] & 0xFF),
        (int) (aSignature[6] & 0xFF),
        (int) (aSignature[7] & 0xFF));
    lpszSignature->SetWindowText(szStatus);
    
    // retrieve the CSP protocol and show it on the display
    wsprintf((LPSTR) szStatus, "%d", cspGetProtocol());
    lpnProtocol->SetWindowText(szStatus);

    // retrieve the CSP system status and show it on the display
    wsprintf((LPSTR) szStatus, "%d", cspGetSystemStatus());
    lpnSystemStatus->SetWindowText(szStatus);

    // retrieve the CSP version and show it on the display
    cspGetSwVersion(szSwVersion, sizeof(szSwVersion));
    lpszSwVersion->SetWindowText(szSwVersion);
}

/*
 ** BOOL CVcCspDemoDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
 *
 *  FILENAME: C:\Symbol\Csp32Proj\VcCspDemo\Src\VcCspDemoDlg.cpp
 *
 *  PARAMETERS:     pHelpInfo: not used
 *
 *  DESCRIPTION:    This function displays the VcCspDemo.hlp file
 *                  when the F1 function key is pressed. 
 *
 *  RETURNS:        TRUE
 *
 */

BOOL CVcCspDemoDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
    AfxGetApp()->WinHelp(0L, HELP_CONTENTS);
    return TRUE;
}

void CVcCspDemoDlg::OnParameterRead() 
{
    long nRetStatus;            // returned status
    HCURSOR hcurSave;           // change cursor during load operation
		
	// change the cursor, this could take a while...
    hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));
    
    // try to get the barcode redundancy setting
    nRetStatus = cspGetParam(nParam, szString, 1);

    // Restore the previous cursor.
    SetCursor(hcurSave);
    
    if (nRetStatus < STATUS_OK)
    {
        errorMsg( nRetStatus );     // display what went wrong...
        return;
    }
    else
    {
        // display the current setting...
        if (szString[0] == 1)
            CheckRadioButton( IDC_PARAMETER_ENABLE, 
                              IDC_PARAMETER_DISABLE, 
                              IDC_PARAMETER_ENABLE);
        else if (szString[0] == 0)
            CheckRadioButton( IDC_PARAMETER_ENABLE, 
                              IDC_PARAMETER_DISABLE, 
                              IDC_PARAMETER_DISABLE);
    }
    
    // update the device status...
    showStats();	
}

void CVcCspDemoDlg::OnParameterSet() 
{
	long nRetStatus;			// returned status	
	HCURSOR hcurSave;			// change cursor during load operation

	// change the cursor, this could take a while...
	hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));

	// check the current state of the radio buttons
	if (IsDlgButtonChecked(IDC_PARAMETER_ENABLE))
	{
		szString[0] = PARAM_ON;
		nRetStatus = cspSetParam(nParam, szString, 1);
	}
	else if (IsDlgButtonChecked(IDC_PARAMETER_DISABLE))
	{
		szString[0] = PARAM_OFF;
		nRetStatus = cspSetParam(nParam, szString, 1);
	}
	else
	{
		// Restore the previous cursor
		SetCursor(hcurSave);
		return;
	}

	// Restore the previous cursor
	SetCursor(hcurSave);

	if (nRetStatus < STATUS_OK)
	{
		errorMsg(nRetStatus);		// display what went wrong
		return;
	}

	// update the device status...
	showStats();
}

void CVcCspDemoDlg::OnParameterEnable() 
{
		CheckRadioButton( IDC_PARAMETER_ENABLE,
						  IDC_PARAMETER_DISABLE,
						  IDC_PARAMETER_ENABLE);
}

void CVcCspDemoDlg::OnParameterDisable() 
{
	CheckRadioButton( IDC_PARAMETER_ENABLE, 
					  IDC_PARAMETER_DISABLE, 
					  IDC_PARAMETER_DISABLE);	
}

void CVcCspDemoDlg::OnKillfocusParameter() 
{
    char Str[3];
 
    GetDlgItemText(IDC_PARAMETER, Str, sizeof(Str));
	nParam = atol(Str);
}
