Attribute VB_Name = "Module1"
'*******************************************************************
'$Header: C:/Symbol/Csp32Proj/VbCspDemo/vcs/csp32h.cpv  1.0  27 Mar 1999  12:00:00 kfallon $
'*
'*  Copyright 1999 Peninsula Solutions, Inc., all rights reserved.
'*  Copyright 1999 Symbol Technologies, Inc., all rights reserved.
'*
'*          ***************************************
'*          * This file was generated by:         *
'*          *       Peninsula Solutions, Inc.     *
'*          *       1265 S. Semoran Blvd.         *
'*          *       Suite 1247                    *
'*          *       Winter Park, FL 32792         *
'*          *       Phone: (407) 673-6544         *
'*          *       Fax:   (407) 673-6545         *
'*          * E-mail: info@PeninsulaSolutions.com *
'*          *                                     *
'*          * under a grant from:                 *
'*          *       Symbol Technologies, Inc.     *
'*          *       Holtsville, NY                *
'*          ***************************************
'*
'* The user is granted a license to use and modify this file for their own
'* purposes so long as the Copyright information remains intact.
'*
'*    MODULE NAME:   Csp32h.bas
'*
'*    DESCRIPTION:
'*
'*                   This file contains is equivelent to a 'h' file in the 'C'
'*                   programming language. It contains all the function prototypes
'*                   and constant definations for the CSP32 DLL.
'*
'*    AUTHOR:        Kim P. Fallon
'*
'*    DATE CREATED:  03/27/99
'*
'*    HISTORY:
'*
'*       03/27/99    Initial Development
'*
'*
'*$Log: C:/Symbol/Csp32Proj/VbCspDemo/vcs/csp32h.cpv $
'*******************************************************************/



'*********************************
'*****  FUNCTION PROTOTYPES  *****
'*********************************

' Communications
Declare Function cspInit Lib "csp32.DLL" (ByVal nComPort As Long) As Long
Declare Function cspRestore Lib "csp32.DLL" () As Long

' Basic Functions
Declare Function cspReadData Lib "csp32.DLL" () As Long
Declare Function cspClearBarCodes Lib "csp32.DLL" () As Long
Declare Function cspPowerDown Lib "csp32.DLL" () As Long

' CSP Data Get
Declare Function cspGetBarcode Lib "csp32.DLL" (ByVal stBarData As String, ByVal lgBarcodeNumber As Long, ByVal maxLength As Long) As Long
Declare Function cspGetDeviceId Lib "csp32.DLL" (ByVal stPenId As String, ByVal lgMaxLength As Long) As Long
Declare Function cspGetSignature Lib "csp32.DLL" (ByVal stSignature As String, ByVal lgMaxLength As Long) As Long
Declare Function cspGetProtocol Lib "csp32.DLL" () As Long
Declare Function cspGetSystemStatus Lib "csp32.DLL" () As Long
Declare Function cspGetSwVersion Lib "csp32.DLL" (ByVal stSwVersion As String, ByVal lgMaxLength As Long) As Long

' CSP Configuration Set
Declare Function cspSetTlBits Lib "csp32.DLL" (ByVal stTlBits As String, ByVal lgMaxLength As Long) As Long
Declare Function cspSetVolume Lib "csp32.DLL" (ByVal lgVolume As Long) As Long
Declare Function cspSetBarcodeRedundancy Lib "csp32.DLL" (ByVal lgOnOff As Long) As Long
Declare Function cspSetUserId Lib "csp32.DLL" (ByVal stUserId As String, ByVal lgMaxLength As Long) As Long
Declare Function cspSetContinuousScanning Lib "csp32.DLL" (ByVal lgOnOff As Long) As Long

' CSP Configuration Get
Declare Function cspGetTlBits Lib "csp32.DLL" (ByVal stTlBits As String, ByVal lgMaxLength As Long) As Long
Declare Function cspGetVolume Lib "csp32.DLL" () As Long
Declare Function cspGetBarcodeRedundancy Lib "csp32.DLL" () As Long
Declare Function cspGetUserID Lib "csp32.DLL" (ByVal stUserId As String, ByVal lgMaxLength As Long) As Long
Declare Function cspGetContinuousScanning Lib "csp32.DLL" () As Long

' DLL Configuration
Declare Function cspGetRetryCount Lib "csp32.DLL" () As Long
Declare Function cspSetRetryCount Lib "csp32.DLL" (ByVal lgRetryCount As Long) As Long

' Miscellaneous
Declare Function cspGetDllVersion Lib "csp32.DLL" (ByVal stDllVersion As String, ByVal inMaxLength As Long) As Long

' Debug
Declare Function cspSetDebugMode Lib "csp32.DLL" (ByVal lgOnOff As Long) As Long
Declare Function cspGetCommInfo Lib "csp32.DLL" (ByVal lgComPort As Long) As Long

' Advanced functions
Declare Function cspReadRawData Lib "csp32.DLL" (ByVal stBuffer As String, ByVal inMaxLength As Long) As Long
Declare Function cspSetParam Lib "csp32.DLL" (ByVal lgParam As Long, ByVal stString As String, ByVal inMaxLengthas As Long) As Long
Declare Function cspGetParam Lib "csp32.DLL" (ByVal lgParam As Long, ByVal stString As String, ByVal inMaxLengthas As Long) As Long
Declare Function cspInterrogate Lib "csp32.DLL" () As Long


'***********************
'*****  CONSTANTS  *****
'***********************

' Returned status values...
Global Const STATUS_OK                As Long = 0
Global Const COMMUNICATIONS_ERROR     As Long = -1
Global Const BAD_PARAM                As Long = -2
Global Const SETUP_ERROR              As Long = -3
Global Const INVALID_COMMAND_NUMBER   As Long = -4
Global Const COMMAND_LRC_ERROR        As Long = -7
Global Const RECEIVED_CHARACTER_ERROR As Long = -8
Global Const GENERAL_ERROR            As Long = -9
Global Const FILE_NOT_FOUND           As Long = 2
Global Const ACCESS_DENIED            As Long = 5

' Parameter Numbers...
Global Const TL_BITS              As Long = 1
Global Const VOLUME               As Long = 2
Global Const BARCODE_REDUNDANCY   As Long = 4
Global Const USER_ID              As Long = 6
Global Const CONTINUOUS_SCANNING  As Long = 18

' Parameter values...
Global Const VOLUME_QUIET   As Long = 0
Global Const VOLUME_LOW     As Long = 1
Global Const VOLUME_MEDIUM  As Long = 2
Global Const VOLUME_HIGH    As Long = 3

Global Const PARM_OFF       As Long = 0
Global Const PARM_ON        As Long = 1

Global Const DETERMINE_SIZE As Long = 0

' Serial Port configuration status values...
Global Const SERIAL_RS232    As Long = 0
Global Const SERIAL_MODEM    As Long = -1
Global Const SERIAL_UNKNOWN  As Long = -2



'*********************************************
'*****  Communications setup section...  *****
'*********************************************
Global Const COM1 As Long = 0
Global Const COM2 As Long = 1
Global Const COM3 As Long = 2
Global Const COM4 As Long = 3
Global Const COM5 As Long = 4
Global Const COM6 As Long = 5
Global Const COM7 As Long = 6
Global Const COM8 As Long = 7
Global Const COM9 As Long = 8
Global Const COM10 As Long = 9
Global Const COM11 As Long = 10
Global Const COM12 As Long = 11
Global Const COM13 As Long = 12
Global Const COM14 As Long = 13
Global Const COM15 As Long = 14
Global Const COM16 As Long = 15

